using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
class HelloWorld
{
    static bool postoji(long n, long [] niz, long k)
    {
        long i = 0;
        for(i=0; i<n; i++)
        {
            if(niz[i] == k)
            {
                return true;
            }
        }
        return false;
    }
    static void pisi(long n, long m, long [,] matrica)
    {
        long i = 0, j = 0;
        for(i=0; i<n; i++)
        {
            for(j=0; j<n; j++)
            {
                Console.Write(matrica[i, j]);
                Console.Write(" ");
            }
            Console.WriteLine();
        }
    }
    static void pisi_niz(long n, long [] matrica)
    {
        long i = 0;
        for(i=0; i<n; i++)
        {
            Console.Write(matrica[i]);
            Console.Write(" ");

        }
        Console.WriteLine();
    }
    static void grupa(long n, long [,] matrica, long x, long y, long [] grupa_A, ref long d)
    {
        long i = 0;
        for(i = 0; i<n; i++)
        {
            if(matrica[i, y] == 2 && !postoji(d, grupa_A, y))
            {
                grupa_A[d++] = y;
                grupa(n, matrica, i, y, grupa_A, ref d);
            }
            if(matrica[x, i] == 2 && !postoji(d, grupa_A, x))
            {
                grupa_A[d++] = x;
                grupa(n, matrica, x, i, grupa_A, ref d);
            }
        }
    }
    static void prvi(long n, long [,] matrica, long a, ref long x, ref long y)
    {
        long i = 0;
        for(i=0; i<n; i++)
        {
            if(matrica[a-1, i] == 2)
            {
                x = a-1;
                y = i;
            }
        }
        
    }
    static void Main()
    {
        string [] ulaz = Console.ReadLine().Split(' ');
        long N = long.Parse(ulaz[0]);
        long M = long.Parse(ulaz[1]);
        long [,] putevi = new long [N, N];

        long i = 0, a=0, b=0, put=0, j = 0;
        for(i=0; i<M; i++)
        {
            ulaz = Console.ReadLine().Split(' ');
            a = long.Parse(ulaz[0]);
            b = long.Parse(ulaz[1]);
            put = long.Parse(ulaz[2]);
            putevi[a-1, b-1] = put+1;
            putevi[b-1, a-1] = put+1;
            //0 = nema, 1 = bez leda, 2 = leda
        }
        ulaz = Console.ReadLine().Split(' ');
        a = long.Parse(ulaz[0]); //pera
        b = long.Parse(ulaz[1]); //mika
        
        Console.WriteLine(-1);
    }
}